// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

class Runtime;
class Scheduler;
class Dispatcher;
class RuntimeStrategyStats;

#include <memory>

class RuntimeStrategy {
	friend class Runtime;

 private:
	virtual auto getScheduler() -> Scheduler& = 0;

	virtual auto getDispatcher() -> Dispatcher& = 0;

 protected:
	virtual ~RuntimeStrategy() = default;

 public:
	virtual auto getStats() -> std::shared_ptr<RuntimeStrategyStats> = 0;
};
