// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

#ifdef EMPER_LOCKED_WAKEUP_SEMAPHORE
#include "lib/sync/LockedSemaphore.hpp"
#endif

#ifdef EMPER_POSIX_WAKEUP_SEMAPHORE
#include "lib/sync/PosixSemaphore.hpp"
#endif

#ifdef EMPER_FUTEX_WAKEUP_SEMAPHORE
#include "lib/sync/SpuriousFutexSemaphore.hpp"
#endif

namespace emper::lib::sync {
#ifdef EMPER_LOCKED_WAKEUP_SEMAPHORE
using WorkerWakeupSemaphore = LockedSemaphore;

#elif defined EMPER_POSIX_WAKEUP_SEMAPHORE
using WorkerWakeupSemaphore = PosixSemaphore;

#elif defined EMPER_FUTEX_WAKEUP_SEMAPHORE
using WorkerWakeupSemaphore = SpuriousFutexSemaphore;

#else
#error Unknown WorkerWakeupSemaphore implementation
#endif
}	 // namespace emper::lib::sync
