// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include <atomic>
#include <cstdint>
#include <memory>

#include "RuntimeStrategy.hpp"

class AbstractWorkStealingScheduler;
class AbstractWorkStealingStats;

class AbstractWorkStealingStrategy : public RuntimeStrategy {
 private:
	std::atomic<std::uint64_t> scheduledFibersToLocal;
	std::atomic<std::uint64_t> scheduledFibersToOverflowQueue;
	std::atomic<std::uint64_t> nextFiberFromLocal;
	std::atomic<std::uint64_t> nextFiberStolen;
	std::atomic<std::uint64_t> nextFiberFromAnywhereQueue;

 protected:
	~AbstractWorkStealingStrategy() override = default;

	friend AbstractWorkStealingScheduler;
	friend AbstractWorkStealingStats;
};
